package com.madeu.controller.web.webvacationmanagement;

import java.io.File;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.madeu.view.web.WebVacationManagementDetailView;
import com.madeu.view.web.WebVacationManagementInsertView;
import org.apache.commons.io.FileUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.Resource;
import org.springframework.core.io.ResourceLoader;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.service.web.webvacationmanagement.WebVacationManagementService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;
import com.madeu.view.web.WebVacationManagementView;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;


@Slf4j
@Controller
public class WebVacationManagementController extends ManagerDraftAction{

	@Autowired
	ResourceLoader resourceLoader;

	@Autowired
	private WebVacationManagementService webVacationManagementService;
	
	@Autowired
	private WebLogHistoryService webLogHistoryService;
	
	/**
	 * 연차관리 정보 리스트 조회
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webvacationmanagement/selectListVacationManagement.do")
	public ModelAndView selectListVacationManagement(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebVacationManagementController selectListVacationManagement START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webVacationManagementService.selectListVacationManagement(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebVacationManagementController selectListVacationManagement END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**
	 * <b>연차관리 정보 엑셀 다운로드 </b>
	 * 페이지 처리 없음 
	 * request: 
	 * response : msgCode, msgDesc
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webvacationmanagement/downloadVacationManagementExcel.do")
	public ModelAndView downloadVacationManagementExcel(HttpSession session, HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file, Model model) {
		log.debug("WebVacationManagementController downloadVacationManagementExcel START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		List<Map<String, Object>> selectListReport = new ArrayList<Map<String,Object>>();
		Map<String, Object> map = new HashMap<String,Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				selectListReport = webVacationManagementService.selectListVacationManagementExcel(paramMap);
				map.put("selectListVacationManagement", selectListReport);
				map.put("name", "vacationManagement");
			}
		}
		catch(Exception e){
			e.printStackTrace();
			return null;
		}
		log.debug("WebVacationManagementController downloadVacationManagementExcel END");
		return new ModelAndView(new WebVacationManagementView(),"map",map);
	}

	/**
	 * <b>연차 일괄등록 양식 다운로드 </b>
	 * 페이지 처리 없음
	 * request:
	 * response : msgCode, msgDesc
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/webvacationmanagement/downloadVacationManagementInsertExcel.do")
	public ModelAndView downloadVacationManagementInsertExcel(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebVacationManagementController downloadVacationManagementInsertExcel START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		List<Map<String, Object>> additionalList = new ArrayList<Map<String,Object>>();
		Map<String, Object> map = new HashMap<String,Object>();

		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				additionalList = webVacationManagementService.selectListMemberExcel(paramMap);
				String fileName = String.valueOf(paramMap.get("fileName"));

				Resource resource = resourceLoader.getResource("classpath:static/sample/"+ fileName);
				File file = resource.getFile();
				map.put("additionalList", additionalList);
				map.put("file", file);
				map.put("name", "vacationManagementInsertForm");
			}
		}
		catch(Exception e){
			e.printStackTrace();
			return null;
		}
		log.debug("WebVacationManagementController downloadVacationManagementInsertExcel END");
		return new ModelAndView(new WebVacationManagementInsertView(),"map",map);
	}

	/**
	 * 연차관리 정보 수정 화면으로 이동.
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webvacationmanagement/updateVacationManagementIntro.do")
	public String  updateVacationManagementIntro(HttpSession session,HttpServletRequest request, HttpServletResponse response, Model model) {
		log.debug("WebVacationManagementController  updateVacationManagementIntro START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return "/web/login/logout";
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webVacationManagementService.updateVacationManagementIntro(paramMap);
				
				model.addAttribute("selectUseYn", map.get("selectUseYn"));
				model.addAttribute("insertUseYn", map.get("insertUseYn"));
				model.addAttribute("updateUseYn", map.get("updateUseYn"));
				model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
				model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return "/web/login/logout";
		}
		log.debug("WebVacationManagementController  updateVacationManagementIntro END");
		return "/web/vacationmanagement/vacationManagementUpdate";
	}
	
	/**
	 * 연차관리 정보 상세 조회
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webvacationmanagement/selectVacationManagement.do")
	public ModelAndView selectVacationManagement(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebVacationManagementController selectVacationManagement START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webVacationManagementService.selectVacationManagement(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebVacationManagementController selectVacationManagement END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**
	 * 연차관리 잔여 연차 조회 (one)
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webvacationmanagement/selectVacationManagementLeftDays.do")
	public ModelAndView selectVacationManagementLeftDays(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebVacationManagementController selectVacationManagementLeftDays START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webVacationManagementService.selectVacationManagementLeftDays(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebVacationManagementController selectVacationManagementLeftDays END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	/**
	 * 발행연차수정 잔여 연차 조회 (one)
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/webvacationmanagement/selectVacationManagementDays.do")
	public ModelAndView selectVacationManagementDays(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebVacationManagementController selectVacationManagementDays START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webVacationManagementService.selectVacationManagementDays(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebVacationManagementController selectVacationManagementDays END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**	
	 * 연차관리 정보 등록
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webvacationmanagement/insertVacationManagement.do")
	public ModelAndView insertVacationManagement(HttpSession session,HttpServletRequest request, HttpServletResponse response, MultipartHttpServletRequest file) {
		log.debug("WebVacationManagementController insertVacationManagement START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();

		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webVacationManagementService.insertVacationManagement(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}

			try {
				HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
				HashMap<String, Object> insertMap = new HashMap<String, Object>();
	
				insertMap.put("url", "/webvacationmanagement/insertVacationManagement.do");
				insertMap.put("func", "insertVacationManagement");
				insertMap.put("funcName", "연차관리 등록");
				insertMap.put("service", "webVacationManagementService");
				insertMap.put("serviceName", "연차관리 등록");
				insertMap.put("requestValue", String.valueOf(paramMap));
				insertMap.put("responseValue", String.valueOf(map));
				insertMap.put("tId", map.get("tId"));
				if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
					insertMap.put("resultCode", "SUCCESS");
				}
				else{
					insertMap.put("resultCode", "ERROR");
				}
				insertMap.put("resultMsg", String.valueOf(errorMsg));
				insertMap.put("muMemberId", paramMap.get("loginMemberId"));
	
				webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		log.debug("WebVacationManagementController insertVacationManagement END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 연차관리 정보 일괄등록
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/webvacationmanagement/insertVacationManagementExcel.do")
	public ModelAndView insertVacationManagementExcel(HttpSession session,HttpServletRequest request, HttpServletResponse response,@RequestParam(value = "file", required = false) MultipartFile file) {
		log.debug("WebVacationManagementController insertVacationManagementExcel START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();

		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webVacationManagementService.insertVacationManagementExcel(paramMap,file);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}

			try {
				HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
				HashMap<String, Object> insertMap = new HashMap<String, Object>();

				insertMap.put("url", "/webvacationmanagement/insertVacationManagement.do");
				insertMap.put("func", "insertVacationManagement");
				insertMap.put("funcName", "연차관리 일괄등록");
				insertMap.put("service", "webVacationManagementService");
				insertMap.put("serviceName", "연차관리 일괄등록");
				insertMap.put("requestValue", String.valueOf(paramMap));
				insertMap.put("responseValue", String.valueOf(map));
				insertMap.put("tId", map.get("tId"));
				if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
					insertMap.put("resultCode", "SUCCESS");
				}
				else{
					insertMap.put("resultCode", "ERROR");
				}
				insertMap.put("resultMsg", String.valueOf(errorMsg));
				insertMap.put("muMemberId", paramMap.get("loginMemberId"));

				webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		log.debug("WebVacationManagementController insertVacationManagementExcel END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 연차관리 정보 수정
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/webvacationmanagement/updateVacationManagement.do")
	public ModelAndView updateVacationManagement(HttpSession session,HttpServletRequest request, HttpServletResponse response, MultipartHttpServletRequest file) {
		log.debug("WebVacationManagementController updateVacationManagement START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();

		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webVacationManagementService.updateVacationManagement(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}

			try {
				HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
				HashMap<String, Object> insertMap = new HashMap<String, Object>();

				insertMap.put("url", "/webvacationmanagement/updateVacationManagement.do");
				insertMap.put("func", "updateVacationManagement");
				insertMap.put("funcName", "연차관리 수정");
				insertMap.put("service", "webVacationManagementService");
				insertMap.put("serviceName", "연차관리 수정");
				insertMap.put("requestValue", String.valueOf(paramMap));
				insertMap.put("responseValue", String.valueOf(map));
				insertMap.put("tId", map.get("tId"));
				if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
					insertMap.put("resultCode", "SUCCESS");
				}
				else{
					insertMap.put("resultCode", "ERROR");
				}
				insertMap.put("resultMsg", String.valueOf(errorMsg));
				insertMap.put("muMemberId", paramMap.get("loginMemberId"));

				webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		log.debug("WebVacationManagementController updateVacationManagement END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	/**
	 * 연차관리 정보 삭제
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webvacationmanagement/deleteVacationManagement.do")
	public ModelAndView deleteVacationManagement(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebVacationManagementController deleteVacationManagement START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		StringBuffer errorMsg = new StringBuffer();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webVacationManagementService.deleteVacationManagement(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
			
			try {
				HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
				HashMap<String, Object> insertMap = new HashMap<String, Object>();
	
				insertMap.put("url", "/webvacationmanagement/deleteVacationManagement.do");
				insertMap.put("func", "deleteVacationManagement");
				insertMap.put("funcName", "연차관리 삭제");
				insertMap.put("service", "webVacationManagementService");
				insertMap.put("serviceName", "연차관리 삭제");
				insertMap.put("requestValue", String.valueOf(paramMap));
				insertMap.put("responseValue", String.valueOf(map));
				insertMap.put("tId", map.get("tId"));
				if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
					insertMap.put("resultCode", "SUCCESS");
				}
				else{
					insertMap.put("resultCode", "ERROR");
				}
				insertMap.put("resultMsg", String.valueOf(errorMsg));
				insertMap.put("muMemberId", paramMap.get("loginMemberId"));
	
				webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		log.debug("WebVacationManagementController deleteVacationManagement END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	/**
	 * <b>연차관리 정보 상세 엑셀 다운로드 </b>
	 * 페이지 처리 없음
	 * request:
	 * response : msgCode, msgDesc
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/webvacationmanagement/downloadVacationManagementDetailExcel.do")
	public ModelAndView downloadVacationManagementDetailExcel(HttpSession session, HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file, Model model) {
		log.debug("WebVacationManagementController downloadVacationManagementDetailExcel START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		List<Map<String, Object>> selectListReport = new ArrayList<Map<String,Object>>();
		Map<String, Object> map = new HashMap<String,Object>();

		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				selectListReport = webVacationManagementService.downloadVacationManagementDetailExcel(paramMap);
				map.put("selectListVacationManagement", selectListReport);
				map.put("name", "vacationManagement");
			}
		}
		catch(Exception e){
			e.printStackTrace();
			return null;
		}
		log.debug("WebVacationManagementController downloadVacationManagementDetailExcel END");
		return new ModelAndView(new WebVacationManagementDetailView(),"map",map);
	}
	
}
